// CNGSOFT's block generator for MINILOAD.I80 loader - sometime in 2018-2019 //

#include <stdio.h> // fopen...
#include <stdlib.h> // atoi...

unsigned char m[1<<16],h[1<<5];
int fputcc(int i,FILE *f) { fputc(i,f); return fputc(i>>8,f); }

int main(int argc,char **argv)
{
	int i=0,j=0,l=0,bit0=0,hold=2560;
	char *s=NULL,*t=NULL;
	while (++i<argc)
	{
		if (!bit0)
			bit0=atoi(argv[i]);
		else if (argv[i][0]==':')
			h[j++]=atoi(&argv[i][1]); // bytes to include within the prefix
		else if (!s)
			s=argv[i];
		else if (!t)
			t=argv[i];
		else if (!(hold=atoi(argv[i])))
			i=argc; // HELP!
	}
	if (i>argc||!bit0||!t)
		return printf("usage: MINILOAD bit0 [:number ...] [+]source [+]target [pause]\n"),1;
	FILE *f;
	if (i=(*s=='+')) ++s; // "+source" skips the first 128 bytes (AMSDOS/+3DOS)
	if (!(f=fopen(s,"rb")))
		return printf("error: cannot open source!\n"),1;
	if (i)
		fread(m,1,128,f);
	l+=fread(m,1,sizeof(m),f);
	fclose(f);
	if (i=(*t=='+')) ++t; // "+target" inserts a +2-byte prefix with the block size!
	if (!(f=fopen(t,"ab")))
		return printf("error: cannot create target!\n"),1;
	int tones=4096,x;
	if (hold<0)
		hold=-hold,tones/=2;
	if (i|j)
	{
		fputc(0x11,f);
		fputcc(bit0*2,f); // PILOT pulse
		fputcc(bit0,f); // SYNC1 pulse
		fputcc(bit0,f); // SYNC2 pulse
		fputcc(bit0,f); // BIT0 pulse
		fputcc(bit0*2,f); // BIT1 pulse
		fputcc(tones,f); // PILOT length
		fputc(8,f); // trailing bits
		fputcc(10,f); // PAUSE in ms
		if (i)
		{
			fputcc(3+j,f); // DATA length (L)
			fputc(0,f); // DATA length (H)
			fwrite(h,1,j,f); // extra bytes
			fputcc(l,f); // block length
			x=l^(l>>8);
		}
		else
		{
			fputcc(1+j,f); // DATA length (L)
			fputc(0,f); // DATA length (H)
			fwrite(h,1,j,f); // extra bytes
			x=0;
		}
		for (i=0;i<j;++i)
			x^=h[i];
		fputc(~x,f);
	}
	fputc(0x11,f);
	fputcc(bit0*2,f); // PILOT pulse
	fputcc(bit0,f); // SYNC1 pulse
	fputcc(bit0,f); // SYNC2 pulse
	fputcc(bit0,f); // BIT0 pulse
	fputcc(bit0*2,f); // BIT1 pulse
	fputcc(tones,f); // PILOT length
	fputc(8,f); // trailing bits
	fputcc(hold,f); // PAUSE in ms
	fputcc(l+1,f); // DATA length (L)
	fputc(0,f); // DATA length (H)
	fwrite(m,1,l,f);
	for (x=0,i=0;i<l;++i)
		x^=m[i];
	fputc(~x,f);
	fclose(f);
	return 0;
}
